Index: CMakeLists.txt
===================================================================
--- CMakeLists.txt	(revision 82cf9c4144a2086e48447137eed678e636a00f35)
+++ CMakeLists.txt	(revision f0fd18a3edd611423e3c194102dc411219d37c70)
@@ -6,4 +6,24 @@
 set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fPIC")
 
+# Set the runtime path of the libraries by default but allow to switch it off:
+option(SET_RPATH "Set runtime path of the ${project} libraries?" ON)
+IF(SET_RPATH)
+  # Set up the RPATH so executables find the libraries even when installed in non-default location
+  SET(CMAKE_MACOSX_RPATH 1)
+  SET(CMAKE_SKIP_BUILD_RPATH  FALSE)
+  SET(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE) 
+  SET(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib")
+
+  # Add the automatically determined parts of the RPATH which point to directories outside
+  # the build tree to the install RPATH
+  SET(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
+
+  # the RPATH to be used when installing, but only if it's not a system directory
+  LIST(FIND CMAKE_PLATFORM_IMPLICIT_LINK_DIRECTORIES "${CMAKE_INSTALL_PREFIX}/lib" isSystemDir)
+  IF(${isSystemDir} EQUAL -1)
+    SET(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib")
+  ENDIF(${isSystemDir} EQUAL -1)
+ENDIF(SET_RPATH)
+    
 # Declare ROOT dependency
 find_package(ROOT COMPONENTS EG Eve Geom Gui GuiHtml GenVector Hist Physics Matrix Graf RIO Tree Gpad RGL MathCore)
@@ -36,5 +56,4 @@
 add_library(Delphes SHARED
   $<TARGET_OBJECTS:classes> 
-  $<TARGET_OBJECTS:display>
   $<TARGET_OBJECTS:modules> 
   $<TARGET_OBJECTS:ExRootAnalysis>
@@ -45,5 +64,17 @@
 )
 
+add_library(DelphesDisplay SHARED
+  $<TARGET_OBJECTS:classes>
+  $<TARGET_OBJECTS:display>
+  $<TARGET_OBJECTS:modules>
+  $<TARGET_OBJECTS:ExRootAnalysis>
+  $<TARGET_OBJECTS:fastjet>
+  $<TARGET_OBJECTS:tcl>
+  $<TARGET_OBJECTS:Hector>
+  $<TARGET_OBJECTS:PUPPI>
+)
+
 target_link_Libraries(Delphes ${ROOT_LIBRARIES} ${ROOT_COMPONENT_LIBRARIES})
+target_link_Libraries(DelphesDisplay ${ROOT_LIBRARIES} ${ROOT_COMPONENT_LIBRARIES})
 
-install(TARGETS Delphes DESTINATION lib)
+install(TARGETS Delphes DelphesDisplay DESTINATION lib)
Index: Makefile
===================================================================
--- Makefile	(revision 82cf9c4144a2086e48447137eed678e636a00f35)
+++ Makefile	(revision f0fd18a3edd611423e3c194102dc411219d37c70)
@@ -17,5 +17,5 @@
 CXXFLAGS += $(ROOTCFLAGS) -Wno-write-strings -D_FILE_OFFSET_BITS=64 -DDROP_CGAL -I. -Iexternal -Iexternal/tcl
 DELPHES_LIBS = $(shell $(RC) --libs) -lEG $(SYSLIBS)
-DISPLAY_LIBS = $(shell $(RC) --evelibs) -lGuiHtml  $(SYSLIBS)
+DISPLAY_LIBS = $(shell $(RC) --evelibs) -lGuiHtml $(SYSLIBS)
 
 ifneq ($(CMSSW_FWLITE_INCLUDE_PATH),)
@@ -42,5 +42,5 @@
 CXXFLAGS += -I$(PYTHIA8)/include
 CXXFLAGS += -I$(PYTHIA8)/include/Pythia8
-OPT_LIBS += -L$(PYTHIA8)/lib -lpythia8 -ldl
+OPT_LIBS += -L$(PYTHIA8)/lib -lpythia8 -ldl -lz
 endif
 endif
Index: cards/CMS_PhaseII/CMS_PhaseII_Substructure_PIX4022_0PU.tcl
===================================================================
--- cards/CMS_PhaseII/CMS_PhaseII_Substructure_PIX4022_0PU.tcl	(revision 82cf9c4144a2086e48447137eed678e636a00f35)
+++ cards/CMS_PhaseII/CMS_PhaseII_Substructure_PIX4022_0PU.tcl	(revision f0fd18a3edd611423e3c194102dc411219d37c70)
@@ -47,13 +47,16 @@
   LeptonFilterLep
   RunPUPPIBase
+  RunPUPPIMerger
   RunPUPPI
 
   PhotonFilter
-
+  
+  PhotonCloner
   PhotonIsolation
   PhotonIsolationCHS
   PhotonEfficiency
   PhotonEfficiencyCHS
-
+  
+  ElectronCloner
   ElectronIsolation
   ElectronIsolationCHS
@@ -62,4 +65,5 @@
   ElectronEfficiencyCHS
 
+  MuonCloner
   MuonIsolation
   MuonIsolationCHS
@@ -153,6 +157,6 @@
 
 module ParticlePropagator ParticlePropagator {
-  #set InputArray PileUpMerger/stableParticles
-  set InputArray Delphes/stableParticles
+  set InputArray PileUpMerger/stableParticles
+  #set InputArray Delphes/stableParticles
 
   set OutputArray stableParticles
@@ -537,5 +541,5 @@
   # assume perfect pile-up subtraction for tracks with |z| > fZVertexResolution
   # Z vertex resolution in m
-  set ZVertexResolution 0.0001
+  set ZVertexResolution {0.0001}
 }
 
@@ -649,7 +653,13 @@
 }
 
-module Merger RunPUPPI {
+module Merger RunPUPPIMerger {
   add InputArray RunPUPPIBase/PuppiParticles
   add InputArray LeptonFilterLep/eflowTracksLeptons
+  set OutputArray PuppiParticles
+}
+
+# need this because of leptons that were added back
+module RecoPuFilter RunPUPPI {
+  set InputArray RunPUPPIMerger/PuppiParticles
   set OutputArray PuppiParticles
 }
@@ -955,4 +965,32 @@
 
 
+##################
+# Muon cloner    #
+##################
+
+module Cloner MuonCloner {
+  set InputArray MuonMomentumSmearing/muons
+  set OutputArray muons
+}
+
+####################
+# Electron cloner  #
+####################
+
+module Cloner ElectronCloner {
+  set InputArray ElectronFilter/electrons
+  set OutputArray electrons
+}
+
+##################
+# Photon cloner  #
+##################
+
+module Cloner PhotonCloner {
+  set InputArray PhotonFilter/photons
+  set OutputArray photons
+}
+
+
 ####################
 # Photon isolation #
@@ -993,5 +1031,5 @@
 
   # particle for which calculate the isolation
-  set CandidateInputArray PhotonFilter/photons
+  set CandidateInputArray PhotonCloner/photons
 
   # isolation collection
@@ -1079,5 +1117,5 @@
 module Isolation ElectronIsolationCHS {
 
-  set CandidateInputArray ElectronFilter/electrons
+  set CandidateInputArray ElectronCloner/electrons
 
   # isolation collection
@@ -1085,4 +1123,8 @@
 
   set OutputArray electrons
+
+  # veto isolation cand. based on proximity to input cand.
+  set DeltaRMin 0.01
+  set UseMiniCone true
 
   set DeltaRMax 0.3
@@ -1182,4 +1224,5 @@
 
 
+
 ##################
 # Muon isolation #
@@ -1205,5 +1248,5 @@
 
 module Isolation MuonIsolationCHS {
-  set CandidateInputArray MuonMomentumSmearing/muons
+  set CandidateInputArray MuonCloner/muons
 
   # isolation collection
@@ -1211,4 +1254,9 @@
 
   set OutputArray muons
+
+
+  # veto isolation cand. based on proximity to input cand.
+  set DeltaRMin 0.01
+  set UseMiniCone true
 
   set DeltaRMax 0.3
Index: cards/CMS_PhaseII/CMS_PhaseII_Substructure_PIX4022_200PU.tcl
===================================================================
--- cards/CMS_PhaseII/CMS_PhaseII_Substructure_PIX4022_200PU.tcl	(revision 82cf9c4144a2086e48447137eed678e636a00f35)
+++ cards/CMS_PhaseII/CMS_PhaseII_Substructure_PIX4022_200PU.tcl	(revision f0fd18a3edd611423e3c194102dc411219d37c70)
@@ -47,13 +47,16 @@
   LeptonFilterLep
   RunPUPPIBase
+  RunPUPPIMerger
   RunPUPPI
 
   PhotonFilter
-
+  
+  PhotonCloner
   PhotonIsolation
   PhotonIsolationCHS
   PhotonEfficiency
   PhotonEfficiencyCHS
-
+  
+  ElectronCloner
   ElectronIsolation
   ElectronIsolationCHS
@@ -62,4 +65,5 @@
   ElectronEfficiencyCHS
 
+  MuonCloner
   MuonIsolation
   MuonIsolationCHS
@@ -537,5 +541,5 @@
   # assume perfect pile-up subtraction for tracks with |z| > fZVertexResolution
   # Z vertex resolution in m
-  set ZVertexResolution 0.0001
+  set ZVertexResolution {0.0001}
 }
 
@@ -649,7 +653,13 @@
 }
 
-module Merger RunPUPPI {
+module Merger RunPUPPIMerger {
   add InputArray RunPUPPIBase/PuppiParticles
   add InputArray LeptonFilterLep/eflowTracksLeptons
+  set OutputArray PuppiParticles
+}
+
+# need this because of leptons that were added back
+module RecoPuFilter RunPUPPI {
+  set InputArray RunPUPPIMerger/PuppiParticles
   set OutputArray PuppiParticles
 }
@@ -955,4 +965,32 @@
 
 
+##################
+# Muon cloner    #
+##################
+
+module Cloner MuonCloner {
+  set InputArray MuonMomentumSmearing/muons
+  set OutputArray muons
+}
+
+####################
+# Electron cloner  #
+####################
+
+module Cloner ElectronCloner {
+  set InputArray ElectronFilter/electrons
+  set OutputArray electrons
+}
+
+##################
+# Photon cloner  #
+##################
+
+module Cloner PhotonCloner {
+  set InputArray PhotonFilter/photons
+  set OutputArray photons
+}
+
+
 ####################
 # Photon isolation #
@@ -993,5 +1031,5 @@
 
   # particle for which calculate the isolation
-  set CandidateInputArray PhotonFilter/photons
+  set CandidateInputArray PhotonCloner/photons
 
   # isolation collection
@@ -1079,5 +1117,5 @@
 module Isolation ElectronIsolationCHS {
 
-  set CandidateInputArray ElectronFilter/electrons
+  set CandidateInputArray ElectronCloner/electrons
 
   # isolation collection
@@ -1085,4 +1123,8 @@
 
   set OutputArray electrons
+
+  # veto isolation cand. based on proximity to input cand.
+  set DeltaRMin 0.01
+  set UseMiniCone true
 
   set DeltaRMax 0.3
@@ -1182,4 +1224,5 @@
 
 
+
 ##################
 # Muon isolation #
@@ -1205,5 +1248,5 @@
 
 module Isolation MuonIsolationCHS {
-  set CandidateInputArray MuonMomentumSmearing/muons
+  set CandidateInputArray MuonCloner/muons
 
   # isolation collection
@@ -1211,4 +1254,9 @@
 
   set OutputArray muons
+
+
+  # veto isolation cand. based on proximity to input cand.
+  set DeltaRMin 0.01
+  set UseMiniCone true
 
   set DeltaRMax 0.3
Index: cards/FCC/FCChh.tcl
===================================================================
--- cards/FCC/FCChh.tcl	(revision 82cf9c4144a2086e48447137eed678e636a00f35)
+++ cards/FCC/FCChh.tcl	(revision f0fd18a3edd611423e3c194102dc411219d37c70)
@@ -6,7 +6,7 @@
 #                Michele Selvaggi (CERN)
 #
-#  Released on: Oct 02th, 2016
+#  Released on: Nov 14th, 2016
 #
-#  Configuration: FCC-hh generic detector without dipole in the forward region, no pile-up
+#  Configuration: FCC-hh baseline detector 
 #
 #######################################
@@ -64,6 +64,4 @@
 
   UniqueObjectFinder
-  
-  GenParticleFilter
 
   TreeWriter
@@ -783,15 +781,4 @@
 }
 
-######################
-# GenParticleFilter 
-######################
-
-# store only interesting particles
-module StatusPidFilter GenParticleFilter {
-  set InputArray Delphes/allParticles
-  set OutputArray filteredParticles
-  set PTMin 0.0
-
-}
 
 ##################
@@ -802,5 +789,4 @@
 # add Branch InputArray BranchName BranchClass
   add Branch Delphes/allParticles Particle GenParticle
-  add Branch GenParticleFilter/filteredParticles FilteredParticle GenParticle
 
   add Branch GenJetFinder/jets GenJet Jet
Index: cards/delphes_card_ATLAS_PileUp.tcl
===================================================================
--- cards/delphes_card_ATLAS_PileUp.tcl	(revision 82cf9c4144a2086e48447137eed678e636a00f35)
+++ cards/delphes_card_ATLAS_PileUp.tcl	(revision f0fd18a3edd611423e3c194102dc411219d37c70)
@@ -334,5 +334,5 @@
   # assume perfect pile-up subtraction for tracks with |z| > fZVertexResolution
   # Z vertex resolution in m
-  set ZVertexResolution 0.0001
+  set ZVertexResolution {0.0001}
 }
 
Index: cards/delphes_card_CMS_PileUp.tcl
===================================================================
--- cards/delphes_card_CMS_PileUp.tcl	(revision 82cf9c4144a2086e48447137eed678e636a00f35)
+++ cards/delphes_card_CMS_PileUp.tcl	(revision f0fd18a3edd611423e3c194102dc411219d37c70)
@@ -464,5 +464,5 @@
   # assume perfect pile-up subtraction for tracks with |z| > fZVertexResolution
   # Z vertex resolution in m
-  set ZVertexResolution 0.0001
+  set ZVertexResolution {0.0001}
 }
 
Index: classes/DelphesClasses.cc
===================================================================
--- classes/DelphesClasses.cc	(revision 82cf9c4144a2086e48447137eed678e636a00f35)
+++ classes/DelphesClasses.cc	(revision f0fd18a3edd611423e3c194102dc411219d37c70)
@@ -254,4 +254,5 @@
   object.Mass = Mass;
   object.IsPU = IsPU;
+  object.IsRecoPU = IsRecoPU;
   object.IsConstituent = IsConstituent;
   object.IsFromConversion = IsFromConversion;
@@ -380,4 +381,5 @@
   Mass = 0.0;
   IsPU = 0;
+  IsRecoPU = 0;
   IsConstituent = 0;
   IsFromConversion = 0;
Index: display/CMakeLists.txt
===================================================================
--- display/CMakeLists.txt	(revision 82cf9c4144a2086e48447137eed678e636a00f35)
+++ display/CMakeLists.txt	(revision f0fd18a3edd611423e3c194102dc411219d37c70)
@@ -13,4 +13,7 @@
 add_library(display OBJECT ${sources} DisplayDict.cxx)
 
+# install headers
+install(FILES ${headers} DESTINATION include/display)
+
 # install pcms if they are created
 if (NOT ${ROOT_VERSION} VERSION_LESS "6.0.0")
Index: display/DelphesBranchElement.cc
===================================================================
--- display/DelphesBranchElement.cc	(revision 82cf9c4144a2086e48447137eed678e636a00f35)
+++ display/DelphesBranchElement.cc	(revision f0fd18a3edd611423e3c194102dc411219d37c70)
@@ -87,18 +87,29 @@
     }
   } else if(TString(GetType())=="MissingET") {
-    TIter itMet(branch_);
+    // MissingET as invisible track (like a photon)
     MissingET *MET;
-    TEveArrow *eveMet;
-    // Missing Et
-    while((MET = (MissingET*) itMet.Next())) {
-      eveMet = new TEveArrow((tkRadius_ * MET->MET/maxPt_)*cos(MET->Phi), (tkRadius_ * MET->MET/maxPt_)*sin(MET->Phi), 0., 0., 0., 0.);
-      eveMet->SetMainColor(GetColor());
-      eveMet->SetTubeR(0.04);
-      eveMet->SetConeR(0.08);
-      eveMet->SetConeL(0.10);
-      eveMet->SetPickable(kTRUE);
+    TEveTrack *eveMet;
+    TEveTrackPropagator *trkProp = new TEveTrackPropagator();
+    trkProp->SetMagField(0., 0., -tk_Bz_);
+    trkProp->SetMaxR(tkRadius_);
+    trkProp->SetMaxZ(tkHalfLength_);
+    if(branch_->GetEntriesFast() > 0) {
+      MET = (MissingET*) branch_->At(0);
+      TParticle pb(13, 1, 0, 0, 0, 0,
+                   (tkRadius_ * MET->MET/maxPt_)*cos(MET->Phi),
+                   (tkRadius_ * MET->MET/maxPt_)*sin(MET->Phi),
+                   0., MET->MET, 0.0, 0.0, 0.0, 0.0);
+      eveMet = new TEveTrack(&pb, 0, trkProp);
       eveMet->SetName("Missing Et");
-      eveMet->SetTitle(Form("Missing Et (%.1f GeV)",MET->MET));
+      eveMet->SetStdTitle();
+      eveMet->SetRnrPoints(0);
+      eveMet->SetMarkerColor(kMagenta);
+      eveMet->SetMarkerStyle(4);
+      eveMet->SetMarkerSize(2.);
+      eveMet->SetLineWidth(2.);
+      eveMet->SetLineStyle(7);
       data_->AddElement(eveMet);
+      eveMet->SetLineColor(GetColor());
+      eveMet->MakeTrack();
     }
   }
Index: display/DelphesBranchElement.h
===================================================================
--- display/DelphesBranchElement.h	(revision 82cf9c4144a2086e48447137eed678e636a00f35)
+++ display/DelphesBranchElement.h	(revision f0fd18a3edd611423e3c194102dc411219d37c70)
@@ -34,5 +34,5 @@
 {
   public:
-    DelphesBranchBase(const char* name="", TClonesArray* branch=NULL, const enum EColor color=kBlack, Float_t maxPt=50.):name_(name),branch_(branch),color_(color) {}
+    DelphesBranchBase(const char* name="", TClonesArray* branch=NULL, const enum EColor color=kBlack, Float_t maxPt=50.):name_(name),maxPt_(maxPt),branch_(branch),color_(color) {}
     virtual ~DelphesBranchBase() {}
     const char* GetName() const { return (const char*)name_; }
Index: doc/genMakefile.tcl
===================================================================
--- doc/genMakefile.tcl	(revision 82cf9c4144a2086e48447137eed678e636a00f35)
+++ doc/genMakefile.tcl	(revision f0fd18a3edd611423e3c194102dc411219d37c70)
@@ -210,5 +210,5 @@
 CXXFLAGS += $(ROOTCFLAGS) -Wno-write-strings -D_FILE_OFFSET_BITS=64 -DDROP_CGAL -I. -Iexternal -Iexternal/tcl
 DELPHES_LIBS = $(shell $(RC) --libs) -lEG $(SYSLIBS)
-DISPLAY_LIBS = $(shell $(RC) --evelibs) -lGuiHtml  $(SYSLIBS)
+DISPLAY_LIBS = $(shell $(RC) --evelibs) -lGuiHtml $(SYSLIBS)
 
 ifneq ($(CMSSW_FWLITE_INCLUDE_PATH),)
@@ -235,5 +235,5 @@
 CXXFLAGS += -I$(PYTHIA8)/include
 CXXFLAGS += -I$(PYTHIA8)/include/Pythia8
-OPT_LIBS += -L$(PYTHIA8)/lib -lpythia8 -ldl
+OPT_LIBS += -L$(PYTHIA8)/lib -lpythia8 -ldl -lz
 endif
 endif
Index: examples/CaloGrid.cpp
===================================================================
--- examples/CaloGrid.cpp	(revision 82cf9c4144a2086e48447137eed678e636a00f35)
+++ examples/CaloGrid.cpp	(revision f0fd18a3edd611423e3c194102dc411219d37c70)
@@ -11,5 +11,5 @@
 #include "display/Delphes3DGeometry.h"
 #include "classes/DelphesClasses.h"
-#include "external/ExRootAnalysis/ExRootConfReader.h"
+#include "ExRootAnalysis/ExRootConfReader.h"
 
 #include "TCanvas.h"
Index: examples/EventDisplay.C
===================================================================
--- examples/EventDisplay.C	(revision 82cf9c4144a2086e48447137eed678e636a00f35)
+++ examples/EventDisplay.C	(revision f0fd18a3edd611423e3c194102dc411219d37c70)
@@ -16,5 +16,5 @@
                   const char *TrackingEfficiency = "ChargedHadronTrackingEfficiency",
                   const char *MuonEfficiency = "MuonEfficiency",
-                  const char *Calorimeters = "Calorimeter",
+                  const char *Calorimeters = "HCal",
                   bool displayGeometryOnly = false)
 {
Index: examples/Validation.cpp
===================================================================
--- examples/Validation.cpp	(revision 82cf9c4144a2086e48447137eed678e636a00f35)
+++ examples/Validation.cpp	(revision f0fd18a3edd611423e3c194102dc411219d37c70)
@@ -1456,9 +1456,12 @@
   TLegend *leg_trkpi_eff_eta = (TLegend*)leg_trkpi_res_eta->Clone();
 
-
-  TGraphErrors gr_trkpi_res_pt[n_etabins], gr_trkpi_eff_pt[n_etabins], gr_trkpi_res_eta[n_ptbins], gr_trkpi_eff_eta[n_ptbins];
+  TGraphErrors *gr_trkpi_res_pt  = new TGraphErrors[n_etabins];
+  TGraphErrors *gr_trkpi_eff_pt  = new TGraphErrors[n_etabins];
+  TGraphErrors *gr_trkpi_res_eta = new TGraphErrors[n_ptbins];
+  TGraphErrors *gr_trkpi_eff_eta = new TGraphErrors[n_ptbins];
   TH1D* h_trkpi_eff_pt, *h_trkpi_eff_eta;
 
-  std::vector<resolPlot> plots_trkpi_res_pt[n_etabins], plots_trkpi_res_eta[n_ptbins];
+  std::vector<resolPlot> *plots_trkpi_res_pt   = new std::vector<resolPlot>[n_etabins];
+  std::vector<resolPlot> *plots_trkpi_res_eta  = new std::vector<resolPlot>[n_ptbins];
 
   // loop over eta bins
@@ -1559,8 +1562,13 @@
   TLegend *leg_trkele_eff_eta = (TLegend*)leg_trkele_res_eta->Clone();
 
-  TGraphErrors gr_trkele_res_pt[n_etabins], gr_trkele_eff_pt[n_etabins], gr_trkele_res_eta[n_ptbins], gr_trkele_eff_eta[n_ptbins];
+  TGraphErrors *gr_trkele_res_pt  = new TGraphErrors[n_etabins];
+  TGraphErrors *gr_trkele_eff_pt  = new TGraphErrors[n_etabins];
+  TGraphErrors *gr_trkele_res_eta = new TGraphErrors[n_ptbins];
+  TGraphErrors *gr_trkele_eff_eta = new TGraphErrors[n_ptbins];
+
   TH1D* h_trkele_eff_pt, *h_trkele_eff_eta;
 
-  std::vector<resolPlot> plots_trkele_res_pt[n_etabins], plots_trkele_res_eta[n_ptbins];
+  std::vector<resolPlot> *plots_trkele_res_pt   = new std::vector<resolPlot>[n_etabins];
+  std::vector<resolPlot> *plots_trkele_res_eta  = new std::vector<resolPlot>[n_ptbins];
 
   // loop over eta bins
@@ -1663,8 +1671,13 @@
 
 
-  TGraphErrors gr_trkmu_res_pt[n_etabins], gr_trkmu_eff_pt[n_etabins], gr_trkmu_res_eta[n_ptbins], gr_trkmu_eff_eta[n_ptbins];
+  TGraphErrors *gr_trkmu_res_pt  = new TGraphErrors[n_etabins];
+  TGraphErrors *gr_trkmu_eff_pt  = new TGraphErrors[n_etabins];
+  TGraphErrors *gr_trkmu_res_eta = new TGraphErrors[n_ptbins];
+  TGraphErrors *gr_trkmu_eff_eta = new TGraphErrors[n_ptbins];
+
   TH1D* h_trkmu_eff_pt, *h_trkmu_eff_eta;
 
-  std::vector<resolPlot> plots_trkmu_res_pt[n_etabins], plots_trkmu_res_eta[n_ptbins];
+  std::vector<resolPlot> *plots_trkmu_res_pt   = new std::vector<resolPlot>[n_etabins];
+  std::vector<resolPlot> *plots_trkmu_res_eta  = new std::vector<resolPlot>[n_ptbins];
 
   // loop over eta bins
@@ -1764,7 +1777,9 @@
   TLegend *leg_ecal_res_eta = new TLegend(0.60,0.59,0.95,0.90);
 
-  TGraphErrors gr_ecal_res_e[n_etabins], gr_ecal_res_eta[n_ptbins];
-
-  std::vector<resolPlot> plots_ecal_res_e[n_etabins], plots_ecal_res_eta[n_ptbins];
+  TGraphErrors *gr_ecal_res_e    = new TGraphErrors[n_etabins];
+  TGraphErrors *gr_ecal_res_eta  = new TGraphErrors[n_ptbins];
+
+  std::vector<resolPlot> *plots_ecal_res_e   = new std::vector<resolPlot>[n_etabins];
+  std::vector<resolPlot> *plots_ecal_res_eta = new std::vector<resolPlot>[n_ptbins];
 
   // loop over eta bins
@@ -1833,7 +1848,9 @@
   TLegend *leg_hcal_res_eta = new TLegend(0.60,0.59,0.95,0.90);
 
-  TGraphErrors gr_hcal_res_e[n_etabins], gr_hcal_res_eta[n_ptbins];
-
-  std::vector<resolPlot> plots_hcal_res_e[n_etabins], plots_hcal_res_eta[n_ptbins];
+  TGraphErrors *gr_hcal_res_e   = new TGraphErrors[n_etabins];
+  TGraphErrors *gr_hcal_res_eta = new TGraphErrors[n_ptbins];
+
+  std::vector<resolPlot> *plots_hcal_res_e   = new std::vector<resolPlot>[n_etabins];
+  std::vector<resolPlot> *plots_hcal_res_eta = new std::vector<resolPlot>[n_ptbins];
 
   // loop over eta bins
@@ -1903,12 +1920,13 @@
   TLegend *leg_pfele_res_eta[n_ptbins];
 
-  TGraphErrors gr_pfele_res_e[n_etabins];
-  TGraphErrors gr_pfele_res_eta[n_ptbins];
-
-  TGraphErrors gr_trkele_res_e[n_etabins];
-  TGraphErrors gr_trkele_res_eeta[n_ptbins];
-
-  std::vector<resolPlot> plots_pfele_res_e[n_etabins], plots_pfele_res_eta[n_ptbins];
-  std::vector<resolPlot> plots_trkele_res_e[n_etabins], plots_trkele_res_eeta[n_ptbins];
+  TGraphErrors *gr_pfele_res_e = new TGraphErrors[n_etabins];
+  TGraphErrors *gr_pfele_res_eta = new TGraphErrors[n_ptbins];
+  TGraphErrors *gr_trkele_res_e = new TGraphErrors[n_etabins];
+  TGraphErrors *gr_trkele_res_eeta = new TGraphErrors[n_ptbins];
+
+  std::vector<resolPlot> *plots_pfele_res_e     = new std::vector<resolPlot>[n_etabins];
+  std::vector<resolPlot> *plots_pfele_res_eta   = new std::vector<resolPlot>[n_ptbins];
+  std::vector<resolPlot> *plots_trkele_res_e    = new std::vector<resolPlot>[n_etabins];
+  std::vector<resolPlot> *plots_trkele_res_eeta = new std::vector<resolPlot>[n_ptbins];
 
   TCanvas *c_pfele_res_e[n_etabins];
@@ -2010,12 +2028,14 @@
   TLegend *leg_pfpi_res_eta[n_ptbins];
 
-  TGraphErrors gr_pfpi_res_e[n_etabins];
-  TGraphErrors gr_pfpi_res_eta[n_ptbins];
-
-  TGraphErrors gr_trkpi_res_e[n_etabins];
-  TGraphErrors gr_trkpi_res_eeta[n_ptbins];
-
-  std::vector<resolPlot> plots_pfpi_res_e[n_etabins], plots_pfpi_res_eta[n_ptbins];
-  std::vector<resolPlot> plots_trkpi_res_e[n_etabins], plots_trkpi_res_eeta[n_ptbins];
+  TGraphErrors *gr_pfpi_res_e     = new TGraphErrors[n_etabins];
+  TGraphErrors *gr_pfpi_res_eta   = new TGraphErrors[n_ptbins];
+
+  TGraphErrors *gr_trkpi_res_e    = new TGraphErrors[n_etabins];
+  TGraphErrors *gr_trkpi_res_eeta = new TGraphErrors[n_ptbins];
+
+  std::vector<resolPlot> *plots_pfpi_res_e     = new std::vector<resolPlot>[n_etabins];
+  std::vector<resolPlot> *plots_pfpi_res_eta   = new std::vector<resolPlot>[n_ptbins];
+  std::vector<resolPlot> *plots_trkpi_res_e    = new std::vector<resolPlot>[n_etabins];
+  std::vector<resolPlot> *plots_trkpi_res_eeta = new std::vector<resolPlot>[n_ptbins];
 
   TCanvas *c_pfpi_res_e[n_etabins];
@@ -2119,12 +2139,14 @@
   TLegend *leg_pfjet_res_eta[n_ptbins];
 
-  TGraphErrors gr_pfjet_res_e[n_etabins];
-  TGraphErrors gr_pfjet_res_eta[n_ptbins];
-
-  TGraphErrors gr_cajet_res_e[n_etabins];
-  TGraphErrors gr_cajet_res_eta[n_ptbins];
-
-  std::vector<resolPlot> plots_pfjet_res_e[n_etabins], plots_pfjet_res_eta[n_ptbins];
-  std::vector<resolPlot> plots_cajet_res_e[n_etabins], plots_cajet_res_eta[n_ptbins];
+  TGraphErrors *gr_pfjet_res_e   = new TGraphErrors[n_etabins];
+  TGraphErrors *gr_pfjet_res_eta = new TGraphErrors[n_ptbins];
+
+  TGraphErrors *gr_cajet_res_e   = new TGraphErrors[n_etabins];
+  TGraphErrors *gr_cajet_res_eta = new TGraphErrors[n_ptbins];
+
+  std::vector<resolPlot> *plots_pfjet_res_e   = new std::vector<resolPlot>[n_etabins];
+  std::vector<resolPlot> *plots_pfjet_res_eta = new std::vector<resolPlot>[n_ptbins];
+  std::vector<resolPlot> *plots_cajet_res_e   = new std::vector<resolPlot>[n_etabins];
+  std::vector<resolPlot> *plots_cajet_res_eta = new std::vector<resolPlot>[n_ptbins];
 
   TCanvas *c_pfjet_res_e[n_etabins];
@@ -2260,5 +2282,6 @@
     TLegend *leg_recele_eff_eta = new TLegend(0.55,0.22,0.90,0.48);
 
-    TGraphErrors gr_recele_eff_pt[n_etabins], gr_recele_eff_eta[n_ptbins];
+    TGraphErrors *gr_recele_eff_pt  = new TGraphErrors[n_etabins];
+    TGraphErrors *gr_recele_eff_eta = new TGraphErrors[n_ptbins];
     TH1D* h_recele_eff_pt, *h_recele_eff_eta;
 
@@ -2325,5 +2348,6 @@
     TLegend *leg_recmu_eff_eta = new TLegend(0.55,0.22,0.90,0.48);
 
-    TGraphErrors gr_recmu_eff_pt[n_etabins], gr_recmu_eff_eta[n_ptbins];
+    TGraphErrors *gr_recmu_eff_pt  = new TGraphErrors[n_etabins];
+    TGraphErrors *gr_recmu_eff_eta = new TGraphErrors[n_ptbins];
     TH1D* h_recmu_eff_pt, *h_recmu_eff_eta;
 
@@ -2390,5 +2414,6 @@
     TLegend *leg_recpho_eff_eta = new TLegend(0.55,0.22,0.90,0.48);
 
-    TGraphErrors gr_recpho_eff_pt[n_etabins], gr_recpho_eff_eta[n_ptbins];
+    TGraphErrors *gr_recpho_eff_pt  = new TGraphErrors[n_etabins];
+    TGraphErrors *gr_recpho_eff_eta = new TGraphErrors[n_ptbins];
     TH1D* h_recpho_eff_pt, *h_recpho_eff_eta;
 
@@ -2455,5 +2480,6 @@
     TLegend *leg_recbjet_eff_eta = new TLegend(0.50,0.22,0.90,0.48);
 
-    TGraphErrors gr_recbjet_eff_pt[n_etabins], gr_recbjet_eff_eta[n_ptbins];
+    TGraphErrors *gr_recbjet_eff_pt  = new TGraphErrors[n_etabins];
+    TGraphErrors *gr_recbjet_eff_eta = new TGraphErrors[n_ptbins];
     TH1D* h_recbjet_eff_pt, *h_recbjet_eff_eta;
 
@@ -2517,5 +2543,6 @@
     TLegend *leg_recbjet_cmis_eta = new TLegend(0.50,0.64,0.90,0.90);
 
-    TGraphErrors gr_recbjet_cmis_pt[n_etabins], gr_recbjet_cmis_eta[n_ptbins];
+    TGraphErrors *gr_recbjet_cmis_pt  = new TGraphErrors[n_etabins];
+    TGraphErrors *gr_recbjet_cmis_eta = new TGraphErrors[n_ptbins];
     TH1D* h_recbjet_cmis_pt, *h_recbjet_cmis_eta;
 
@@ -2579,5 +2606,6 @@
     TLegend *leg_recbjet_lmis_eta = new TLegend(0.50,0.64,0.90,0.90);
 
-    TGraphErrors gr_recbjet_lmis_pt[n_etabins], gr_recbjet_lmis_eta[n_ptbins];
+    TGraphErrors *gr_recbjet_lmis_pt  = new TGraphErrors[n_etabins];
+    TGraphErrors *gr_recbjet_lmis_eta = new TGraphErrors[n_ptbins];
     TH1D* h_recbjet_lmis_pt, *h_recbjet_lmis_eta;
 
@@ -2644,5 +2672,6 @@
     TLegend *leg_rectaujet_eff_eta = new TLegend(0.50,0.22,0.90,0.48);
 
-    TGraphErrors gr_rectaujet_eff_pt[n_etabins], gr_rectaujet_eff_eta[n_ptbins];
+    TGraphErrors *gr_rectaujet_eff_pt  = new TGraphErrors[n_etabins];
+    TGraphErrors *gr_rectaujet_eff_eta = new TGraphErrors[n_ptbins];
     TH1D* h_rectaujet_eff_pt, *h_rectaujet_eff_eta;
 
@@ -2708,5 +2737,6 @@
     TLegend *leg_rectaujet_mis_eta = new TLegend(0.50,0.64,0.90,0.90);
 
-    TGraphErrors gr_rectaujet_mis_pt[n_etabins], gr_rectaujet_mis_eta[n_ptbins];
+    TGraphErrors *gr_rectaujet_mis_pt  = new TGraphErrors[n_etabins];
+    TGraphErrors *gr_rectaujet_mis_eta = new TGraphErrors[n_ptbins];
     TH1D* h_rectaujet_mis_pt, *h_rectaujet_mis_eta;
 
Index: external/ExRootAnalysis/CMakeLists.txt
===================================================================
--- external/ExRootAnalysis/CMakeLists.txt	(revision 82cf9c4144a2086e48447137eed678e636a00f35)
+++ external/ExRootAnalysis/CMakeLists.txt	(revision f0fd18a3edd611423e3c194102dc411219d37c70)
@@ -12,10 +12,6 @@
 add_library(ExRootAnalysis OBJECT ${sources} ExRootAnalysisDict.cxx)
 
-# install headers needed by public Delphes headers to include/
-install(FILES ExRootTask.h ExRootConfReader.h ExRootTreeWriter.h ExRootTreeBranch.h
-        DESTINATION include/ExRootAnalysis)
-
-# install all LinkDef files into the same folder to ease user environment
-install(FILES ExRootAnalysisLinkDef.h DESTINATION include)
+# install headers
+install(FILES ${headers} DESTINATION include/ExRootAnalysis)
 
 # install pcms if they are created
Index: modules/CMakeLists.txt
===================================================================
--- modules/CMakeLists.txt	(revision 82cf9c4144a2086e48447137eed678e636a00f35)
+++ modules/CMakeLists.txt	(revision f0fd18a3edd611423e3c194102dc411219d37c70)
@@ -19,8 +19,6 @@
 add_library(modules OBJECT ${sources} FastJetDict.cxx ModulesDict.cxx)
 
-# install public headers
-install(FILES Delphes.h
-        DESTINATION include/modules
-)
+# install headers
+install(FILES ${headers} DESTINATION include/modules)
 
 # install pcms if they are created
Index: modules/RunPUPPI.cc
===================================================================
--- modules/RunPUPPI.cc	(revision 82cf9c4144a2086e48447137eed678e636a00f35)
+++ modules/RunPUPPI.cc	(revision f0fd18a3edd611423e3c194102dc411219d37c70)
@@ -166,5 +166,4 @@
   Candidate *pv = static_cast<Candidate*>(fPVItInputArray->Next());
   if (pv) PVZ = pv->Position.Z();
-
   // Fill input particles for puppi
   std::vector<RecoObj> puppiInputVector;
@@ -179,6 +178,5 @@
       curRecoObj.phi = momentum.Phi();
       curRecoObj.m   = momentum.M();  
-      particle = static_cast<Candidate*>(candidate->GetCandidates()->Last());
-      //if(fApplyNoLep && TMath::Abs(candidate->PID) == 11) continue; //Dumb cut to minimize the nolepton on electron
+      particle = static_cast<Candidate*>(candidate->GetCandidates()->At(0));//if(fApplyNoLep && TMath::Abs(candidate->PID) == 11) continue; //Dumb cut to minimize the nolepton on electron
       //if(fApplyNoLep && TMath::Abs(candidate->PID) == 13) continue;
       if (candidate->IsRecoPU and candidate->Charge !=0) { // if it comes fromPU vertexes after the resolution smearing and the dZ matching within resolution
@@ -192,5 +190,5 @@
         curRecoObj.dZ = particle->Position.Z()-PVZ;
       } 
-      else if(!candidate->IsRecoPU and candidate->Charge !=0) {
+      else if(!candidate->IsRecoPU && candidate->Charge !=0) {
 	curRecoObj.id    = 1;  // charge from LV
         curRecoObj.vtxId = 1; // from PV
@@ -219,6 +217,5 @@
       curRecoObj.m   = momentum.M();
       curRecoObj.charge = 0;
-      particle = static_cast<Candidate*>(candidate->GetCandidates()->Last());
-
+      particle = static_cast<Candidate*>(candidate->GetCandidates()->At(0));
       if(candidate->Charge == 0){
 	curRecoObj.id    = 0; // neutrals have id==0
Index: modules/TrackPileUpSubtractor.cc
===================================================================
--- modules/TrackPileUpSubtractor.cc	(revision 82cf9c4144a2086e48447137eed678e636a00f35)
+++ modules/TrackPileUpSubtractor.cc	(revision f0fd18a3edd611423e3c194102dc411219d37c70)
@@ -53,6 +53,8 @@
 //------------------------------------------------------------------------------
 
-TrackPileUpSubtractor::TrackPileUpSubtractor()
+TrackPileUpSubtractor::TrackPileUpSubtractor() :
+fFormula(0) 
 {
+  fFormula = new DelphesFormula;
 }
 
@@ -61,4 +63,5 @@
 TrackPileUpSubtractor::~TrackPileUpSubtractor()
 {
+  if(fFormula) delete fFormula;
 }
 
@@ -72,5 +75,6 @@
   fItVertexInputArray = fVertexInputArray->MakeIterator();
 
-  fZVertexResolution  = GetDouble("ZVertexResolution", 0.005)*1.0E3;
+  // read resolution formula in m
+  fFormula->Compile(GetString("ZVertexResolution", "0.001"));
 
   fPTMin = GetDouble("PTMin", 0.);
@@ -119,4 +123,5 @@
   TObjArray *array;
   Double_t z, zvtx=0;
+  Double_t pt, eta, phi, e;
 
 
@@ -144,4 +149,11 @@
     {
       particle = static_cast<Candidate*>(candidate->GetCandidates()->At(0));
+      const TLorentzVector &candidateMomentum = particle->Momentum;
+
+      eta = candidateMomentum.Eta();
+      pt = candidateMomentum.Pt();
+      phi = candidateMomentum.Phi();
+      e = candidateMomentum.E();
+      
       z = particle->Position.Z();
 
@@ -149,5 +161,5 @@
       // assume perfect pile-up subtraction for tracks outside fZVertexResolution
 
-      if(candidate->IsPU && TMath::Abs(z-zvtx) > fZVertexResolution)
+      if(candidate->Charge !=0 && TMath::Abs(z-zvtx) > fFormula->Eval(pt, eta, phi, e)* 1.0e3)
       {
         candidate->IsRecoPU = 1;
@@ -161,4 +173,2 @@
   }
 }
-
-//------------------------------------------------------------------------------
